SystemOrganization addCategory: #'Pier-YubiKey'!

!PUUser methodsFor: '*Pier-YubiKey' stamp: 'pmm 10/5/2008 19:57'!
yubiKey
	^self propertyAt: #yubiKey ifAbsent: [ nil ]! !

!PUUser methodsFor: '*Pier-YubiKey' stamp: 'pmm 10/5/2008 21:23'!
yubiKey: aString
	^self propertyAt: #yubiKey put: aString! !

MAValidationError subclass: #PYInvalidLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-YubiKey'!

PRCommand subclass: #PYLogin
	instanceVariableNames: 'yubiKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-YubiKey'!

!PYLogin class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:50'!
descriptionYubiKey
	^ MAStringDescription new
		accessor: #yubiKey;
		label: 'YubiKey';
		priority: 200;
		beRequired;
		yourself! !

!PYLogin class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:46'!
isValidIn: aContext
	^ aContext isLoggedIn not! !

!PYLogin methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:34'!
doValidate
	super doValidate.
	self validateOtp! !

!PYLogin methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:30'!
invalidLogin
	self subclassResponsibility! !

!PYLogin methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:46'!
isLogged
	^ false! !

!PYLogin methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:46'!
mementoClass
	^ MACachedMemento! !

!PYLogin methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:31'!
userForOtp
	yubiKey := self yubiKey first: 12.
	^self kernel users
		detect: [ :each | each yubiKey = yubiKey ]
		ifNone: [ self invalidLogin ]! !

!PYLogin methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:33'!
validateOtp
	(YKYubicoVerifier new verfiy: self yubiKey)
		ifFalse: [ self invalidLogin ]! !

!PYLogin methodsFor: 'accessing' stamp: 'pmm 10/5/2008 19:47'!
yubiKey
	^ yubiKey! !

!PYLogin methodsFor: 'accessing' stamp: 'pmm 10/5/2008 19:48'!
yubiKey: aString
	yubiKey := aString! !

PYLogin subclass: #PYOneFactor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-YubiKey'!

!PYOneFactor class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:45'!
isAbstract
	^false! !

!PYOneFactor class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:47'!
label
	^ 'Login YubiKey one factor'! !

!PYOneFactor methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:31'!
doValidate
	super doValidate.
	self user: self userForOtp! !

!PYOneFactor methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:29'!
invalidLogin
	PUInvalidLogin
		description: self description
		signal: 'Invalid YubiKey'! !

PYLogin subclass: #PYTwoFactor
	instanceVariableNames: 'password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-YubiKey'!

!PYTwoFactor class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:50'!
descriptionPassword
	^ MAPasswordDescription new
		accessor: #password;
		label: 'Password';
		priority: 100;
		beRequired;
		yourself! !

!PYTwoFactor class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:45'!
isAbstract
	^false! !

!PYTwoFactor class methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 19:47'!
label
	^ 'Login YubiKey two factor'! !

!PYTwoFactor methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:35'!
doValidate
	| user |
	super doValidate.
	user := self userForOtp.
	user password = self password
		ifTrue: [ self user: user ]
		ifFalse: [ self invalidLogin ]! !

!PYTwoFactor methodsFor: 'as yet unclassified' stamp: 'pmm 10/5/2008 21:29'!
invalidLogin
	PUInvalidLogin
		description: self description
		signal: 'Invalid YubiKey or password'! !

!PYTwoFactor methodsFor: 'accessing' stamp: 'pmm 10/5/2008 19:50'!
password
	^ password! !

!PYTwoFactor methodsFor: 'accessing' stamp: 'pmm 10/5/2008 19:50'!
password: aString
	password := aString! !
